### From The MPEG-4 Structured Audio Book by John Lazzaro and John Wawrzynek.

# Appendix E: Language Elements

#### Bus Elements

`

    inchannels
    input_bus
    outchannels
    output_bus

`

#### Core Opcodes

See other appendices for core opcode lists sorted alphabetically and by function.

#### Core Wavetable Generators

See this appendix for the list of wavetable generators.

#### Expression Elements

`

    sasbf

`

#### Expression Operators

`

+ - * / == != <= >= && || ! ? : =

`

#### Global Parameters

`

    interp
    inchannels
    krate
    outchannels
    srate

`

#### SASL Commands

`

    instr
    control
    tempo
    end
    table

`

#### Standard Names

See this appendix for the list of standard names.

#### Statements

`

    assignment
    extend
    if
    if-else
    instr
    outbus
    output
    return
    route
    send
    sequence
    spatialize
    turnoff
    while

`

#### Top-Level Declarations

`

    aopcode
    global
    instr
    iopcode
    kopcode
    opcode
    preset
    template
    map
    with

`

#### Variable Declarations

`

    asig
    exports
    imports
    ivar
    ksig
    oparray
    table
    tablemap
    xsig

`

Appendix F:

Language Rules

Copyright 1999 John Lazzaro and John Wawrzynek.